! "@(#) $Id: EXTfocwalign.prg,v 1.1.1.1 2010/04/19 08:36:40 kbanse Exp $"
! wdgalign.prg	1.3 (ESO-ASD) 5/4/95 17:46:05
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.IDENT      wdgalign.prg
!.PURPOSE    Align focus wedge
!.USE        @c wdgalign
!.AUTHOR     Cristian Levin/modified by Paul Le saux
!.VERSION    1.0       01/06/92  Creation
!.VERSION    2.0       17/05/94  Cleaned up - K.Banse
!.VERSION    2.1       10/01/95  implementation of parameters file (CL)
!.VERSION    2.2       27/06/95  measure disalignment (PL)
!.KEYWORDS 
! --------------------------------------------------------------
!
! EXTERNAL VARIABLES:
! teloffs, camoffs, signwedg, distwedg,conswedg 
!

defi/par P1 ? I "Frame name :"

define/local dx/r/1/1 0.0
define/local dy/r/1/1 0.0
define/local dc/r/1/1 0.0
define/local  m/r/1/1 0.0
define/local dtelf/r/1/1 0.0
define/local yleft/r/1/1 0.0
define/local yright/r/1/1 0.0
define/local dcamf/r/1/1 0.0
define/local tel/i/1/1 0
!define/local distwedg/i/1/1 0
define/local grconst/r/1/1 0.
echo/off
! Focus wedge parameters
! distance between the peers for the wedge focus computation
write/key distwedg/r/1/1 62.0    
! Y-shift sign for the wedge focus computation
write/key signwedg/i/1/1        -1
write/key conswedg/r/1/3        4.8,6.6,12
write/out "Focus constants : {conswedg(1)},{conswedg(2)},{conswedg(3)}"
write/key teloffs/r/1/1		6.6	!  20/12/97

cuts/ima {P1} =sigma
load/ima {P1} 

! 
create/table focleft 15 0 null
create/table focright 15 0 null
clear/chan overlay
! 
!center/gauss cursor focleft
center/gauss {P1},/vlt/insroot/SYSTEM/COMMON/CONFIGFILES/wedge focleft

!center/gauss {P1},wedge focleft

if outputi(1) .eq. 0 then
    write/out
    write/out "Invalid number of coordinates."
    echo/off
    return
endif
!
define/local ioff/i/1/2 0,0
ioff = ididev(6)*ididev(15)+1           !offset into keyword IDIMEMC
ioff(2) = ioff(1)+79
!
define/local cmc/c/1/80 {idimemc({ioff}:{ioff(2)})}

write/out "Telescope 360 teloffs, camoffs, signwedg, distwedg, conswedg, "
teloffs = conswedg(1)
grconst = 1000. / 1.08
distwedg = 62
dx = distwedg
! 
compute/table focleft :xstart = :xstart + {dx}
compute/table focleft :xend = :xend + {dx}
! 
!

center/gauss {cmc},focleft focright

load/tab focright :xcen :ycen ? 2 6
! 
set/midas output=no
! 
statist/table focleft :ycen
yleft = outputr(3)     ! minimum value
statist/table focright :ycen
yright = outputr(3)    ! minimum value
! 
! set/midas output=yes
! 
! Y-shift
dy = -1*signwedg * (yright-yleft)
!
! Slope in degres 
m = M$ATAN(dy/{distwedg})
!
! TELESCOPE focus offset 
dtelf = -1 * teloffs * dy
!
! EFOSC2 camera correction
dcamf = camoffs * dy
!
! Local grism offset wheel ( e. units)
dc = {grconst} * {m}

set/midas output=yes 
write/out
write/out
set/format F8.3
write/out "(Yleft - Yright)    = {dy}"
write/out "Slope in degrees    = {m}"
write/out "Local grism Delta Offset  = {dc}"
write/out " "
write/out "M2 offset (e.u)     = {dtelf}"
write/out "Efosc Camera Offset = {dcamf}"
! write/out "Local grism Offset  = {dc}"

! Output for Templates

outputr(1) = {dy}
outputr(2) = {dc}
outputr(3) = {dtelf}
outputr(4) = {m}
read/key outputr
echo/off
