!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.IDENT      EXThartslits.prg
!.PURPOSE    Measure Hartmann FOCUS
!.USE        @@ EXThartslits 'HARTlow' 'HARTup'
!.AUTHOR     Paul Le Saux
!.VERSION    1.0       14/3/95
! 100407	last modif
! ------------------------------------------------------
!
if M$EXISTK("lo") .eq. 0 then
  define/local lo/i/1/1 0
endif
! 
define/local z1/c/1/16 " " all
define/local z2/c/1/16 " " all
define/local nx/i/1/1 0
define/local ny/i/1/1 0
define/local exist/i/1/1 0
define/local adda/r/1/1 0.
define/local degree/i/1/1 2	! Regression degree
define/local no/c/1/2  no
define/local ask/c/1/2  aa
define/local nx2/i/1/1 0
define/local ny2/i/1/1 0
define/local lng/i/1/1 0
define/local numsel/i/1/1 0
define/local numpoint/i/1/1 0
define/local count/i/1/1  0
define/local cc/r/1/1  2.  
define/local sigma/r/1/1 0.
define/local spread/r/1/1 0.
define/local collfactor/r/1/1 -0.65  ! Collimator factor (mm)/pix (bin 1x1)
define/local correc/r/1/1 0.
define/local min/i/1/1 0
define/local max/i/1/1 0
define/local precis/r/1/1 0.
define/local prcs/r/1/1 0.
define/local shift/r/1/1 0.
define/local pxsz/i/1/1 0
define/local lowX/r/1/1 1
define/local uppX/r/1/1 8
define/local xx/r/1/1 1
define/local iloop/i/1/1 1
define/local nloop/i/1/1 32
define/local minr/r/1/1 0
define/local maxr/r/1/1 0
delete/table horizFoc no
! 
if dazdevr(10) .eq. -1 then
  create/display
endif
! 
if ididev(1) .le. 0 then
  create/graphic
endif
SET/GRAPHICS DEFAULT
set/graphics pmode=1
set/graphics yaxis=auto
set/graphics xaxis=auto
!  
set/overlay
clear/channel ov
load/lut heat
! 
clear/context -all
! 
set/context spec
! 
indisk/fits {P1} z1
indisk/fits {P2} z2
! 
do iloop = 1 nloop
  lowX = (iloop - 1) * 1800. / nloop + 150
  uppX = iloop * 1800. / nloop + 150
  xx   = 0.5 * (lowX + uppX)
  write/out
  write/out "{iloop} {nloop} {lowX} {uppX} {xx}"
  write/out 
  !
  extract/image spectre1 = z1[{lowX},1:{uppX},2000]
  extract/image spectre2 = z2[{lowX},1:{uppX},2000]
  !
  load spectre2 cuts=f,ihap  scale=-4
  !
  average/col spectre = spectre1 
  average/col spectra = spectre2 
  !
  set/graphics colour=1
  plot spectra
  set/graphics colour=2
  overplot spectre
  log(4) = {lo}
  !
  search/line spectra 20,1000 mex maximum
  ! 
  proj/table mex listmex :X
  comput/table listmex :XSTART = :X - 7
  comput/table listmex :XEND = :X + 7
  delete/column listmex :X
  center/gaus spectra,listmex sa
  center/gaus spectre,listmex se
  create/table fusion 10  1
  create/column fusion :xa
  create/column fusion :xe
  create/column fusion :xdiff
  create/column fusion :xx
  compute/table fusion :xx = {xx}
  copy/tt   sa :xfwhm fusion :xfwhma
  copy/tt   se :xfwhm fusion :xfwhmb
  copy/tt   sa :xcen fusion :xa
  copy/tt   se :xcen fusion :xe
  log(4) = 0
  select/table fusion :xa.gt.-10000
  !read/keyw outputi
  if outputi(1) .lt. 2 then
    if outputi(1) .lt. 1 then
      log(4) = 0
      write/out "No line found"
      errsum = errsum + 1
      return
    else
      write/out "1 line found"
      compute/table fusion :xdiff = :xe - :xa
      log(4) = 0
      read/table fusion
      !numsel = 1
      !numpoint = 1
      spread = 0.
      precis = 0
      shift = {fusion,:xdiff,@1}
      ! 
      if m$exist("horizFoc.tbl") .eq. 1 then
	  merge/table horizFoc fusion temp
	  copy/table temp horizFoc
      else
	   copy/table fusion horizFoc
      endif
    endif
  else
      write/out "too many lines found"   
      errsum = errsum + 1
      return
  endif
enddo
! 
numsel = outputi(1)
numpoint = numsel
degree = 2
! 
compute/table horizFoc :xdiff = :xe - :xa
compute/table horizFoc :xa = :xx
! 
!verify table horizFoc
! 
statistics/table horizFoc :xx  >Null
write/key rcorr/r/1/4   178.125,1921.88,1050,527.672,1008.45 
@@ kcompare slit010:rcorr outputr 1,4 0.01
statistics/table horizFoc :xfwhma  >Null
write/key rcorr/r/1/4    1.88827,2.10922,1.96873,0.052452 
@@ kcompare slit012:rcorr outputr 1,4 0.0001
statistics/table horizFoc :xfwhmb  >Null
write/key rcorr/r/1/4     1.94981,2.13118,2.01729,0.0431549
@@ kcompare slit014:rcorr outputr 1,4 0.0001
! 
copy/table horizFoc fusion
! 
!verify table fusion
! 
statistics/table fusion :xdiff  >Null
write/key rcorr/r/1/4       -0.500122,0.00848389,-0.306194,0.16056
@@ kcompare slit018:rcorr outputr 1,4 0.0001
! 
clear/graph
! 
write/key  count/i/1/1  0
write/key  cc/r/1/1  2.  
write/key sigma/r/1/1 0.
stat/table fusion :xa
! 
statistics/table fusion :xa  >Null
write/key rcorr/r/1/4         178.125,1921.88,1050,527.672 
@@ kcompare slit020:rcorr outputr 1,4 0.02
! 
set/graphics xaxis='outputr(1)','outputr(2)'
! 
copy/table fusion f1
compute/table fusion :tresp = 0.
! 
boucle:
! 
copy/table fusion f1
set/format F16.7
regres/poly f1 :xdiff :xa {degree}
save/regression  f1 parab
compute/regr f1 :tresp  = parab(:xa) 
compute/table  f1 :xdist = abs( :xdiff - :tresp )
! 
sigma = outputr(5)
statistics/table f1 :xdiff
write/key rcorr/r/1/4   -0.500122,0.00848389,-0.306194,0.16056 
@@ kcompare slit030:rcorr outputr 1,4 0.0001
! 
write/key spread/r/1/1 0.
spread = ( {outputr(2)} - {outputr(1)} )
! 
statistics/table f1 :xdist
write/key disp/r/1/1 {outputr(3)}
!
log(4) = 0
write/out 
write/out "spread      =" {spread}  " R.M.S. =" 'sigma' " error bar =" 'cc'
write/out "dispersion  =" {disp}  " R.M.S. =" 'sigma' " error bar =" 'cc'
write/out 
log(4) = {lo}
!
write/keyw rcorr/r/1/4 0.508606,0.0140967,0.0106889,2.0
outputr(1) = spread
outputr(2) = sigma
outputr(3) = disp
outputr(4) = cc
@@ kcompare slit035:rcorr outputr 1,3 0.0001 4,4 0.01
! 
spread = {spread} * 0.05
name/column f1 :xa "pixels"
name/column f1 :xdiff "pixels"
! 
set/graphics colour=4
plot/table f1 :xa :xdiff 
set/graphics colour=2
over/table f1 :xa :tresp  2
compute/table f1 :tb = :tresp -'sigma'*'cc'
compute/table f1 :th = :tresp +'sigma'*'cc'
set/graphics colour=3
over/table f1 :xa :tb 4
over/table f1 :xa :th 4
! 
nextsel:
! 
compute/table f1 :dff = ABS(:xdiff-:tresp)  
if sigma .le. spread goto fit
! 
log(4) = 0
select/table f1 :dff.LT.{sigma}*{cc}
log(4) = {lo}
! 
if outputi(1) .eq. 4 goto back
! 
if numsel .eq. outputi(1)  .or. count .ge. 15  goto fit
! 
if count .ge. 3  cc = cc + 0.1
numsel = outputi(1)
count = count+1
copy/table  f1 fusion
goto boucle
! 
! 
back:
! 
log(4) = 0
write/out " IMPOSSIBLE TO ELIMINATE MORE POINTS "
copy/table fusion f1
! 
fit: 
!
convert/table kurva = f1 :xa :tresp spectre polinomial {degree}
statistics/table f1 :xa
write/key rcorr/r/1/4  178.125,1921.88,1050,527.672
@@ kcompare slit040:rcorr outputr 1,4 0.01
! 
min = outputr(1) + 2
max = outputr(2) - 2
! 
wait/sec 1			!otherwise we miss the pretty plot before
set/graphics colour=4
plot/table f1 :xa :xdiff
set/graphics colour=2
over kurva 1 'min','max'
set/graphics colour=1
over/line  1 'min',0. 'max',0. 
set/graphics colour=3
over/line  1 'min','outputr(3)' 'max','outputr(3)'
copy/graphics postscript
$cp postscript.ps hartslits.ps
! 
statistics/ima kurva [{min}:{max}] OPTION=RN
write/key rcorr/r/1/4   -0.481708,0.0407576,-0.31732,0.14772 
@@ kcompare slit044:rcorr outputr 1,4 0.0001
! 
spread = outputr(2) - outputr(1)
precis = outputr(3) * 100.  / spread
prcs =  M$ABS(precis)
outputr(1) = prcs
outputr(2) = collfactor
write/keyw rcorr/r/1/2 60.7352,-0.65
@@ kcompare slit047:rcorr outputr 1,2 0.001
! 
pxsz = 1
shift = outputr(3) 
correc = collfactor*shift
! 
result:
! 
log(4) = 0
write/out
write/out
set/format I1 F10.2
write/out {numsel} " points selected out of " {numpoint} " found" 
write/out
set/format I1 F10.3
!write/out "Pixel size      : "  {pxsz}  "microns"
!write/out
write/out "Focus shift     : "  {shift} "pixels"
write/out
write/out "Focus dispersion    : " {disp} "pixels"
write/out
write/out "Focus spread    : " {spread} "pixels"
write/out
write/out "Increase collimator position by {correc} (mm) "
write/out
set/format I1 F10.3
write/out "Focus accuracy : " {precis} "% of spread"
write/out
if prcs .lt. 25. then
  write/out "Instrument in FOCUS ."
else
  write/out "FOCUS accuracy should be lower than 25 % of spread "
endif
write/out 
! 
write/keyw rcorr/r/1/4 -0.317,0.0107,0.2063,-60.735,0.522
outputr(1) = shift
outputr(2) = disp
outputr(3) = correc
outputr(4) = precis
outputr(5) = spread
@@ kcompare slit050:rcorr outputr 1,4 0.001
lo = 0
copy/graphics postscript
$cp postscript.ps fwhmslits.ps
set/graphics colour=1
! 
clear/context -all
! 
delete/table fusion no
delete/table mex no
delete/table listmex no
delete/image spectra no
delete/image spectre no
 
